''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'                                                                            '
'                 TerraBattles ProtoRPG v0.5.5 Town Engine                   '
'                                                                            '
'                              Module v0.4.0                                 '
'                      Last modified: 18 July 1998                           '
'                                                                            '
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

DECLARE SUB QuestTempsLoad ()
DECLARE SUB QuestTempsSave ()
DECLARE SUB ChangeMap ()
DECLARE SUB CheckTile ()
DECLARE SUB LoadText (tlk$)
DECLARE SUB DecisionBox (choices%, c1$, c2$, c3$, c4$, c5$)
DECLARE SUB DialogWait (mode%)
DECLARE SUB TownSearch ()
DECLARE SUB TownTalk ()
DECLARE SUB TownMenu ()
DECLARE SUB TownStatusMenu ()
DECLARE SUB DialogBox (clearbox%, picturebox%, textbox%)
DECLARE SUB Mapping ()
DECLARE SUB UpdateSprites ()
DECLARE SUB RagnarIcon ()
DECLARE SUB MechIcon ()
DECLARE SUB Farewell ()
DECLARE SUB HitAnyKey ()
DECLARE SUB ReloadMap ()
DECLARE SUB AnimeLoad (anime$)
DECLARE SUB LoadInfo ()
DECLARE SUB LoadTiles ()
DECLARE SUB LoadMaps ()

DIM SHARED MountainTile%(129), HillTile%(129), Items$(1 TO 20), KingDownSprite%(129), KingDownMask%(129)
DIM SHARED Kate%(1052), TavernTile%(129), ChestOpenTile%(129), MouseCursor%(152)
DIM SHARED KnightSprite%(129), KnightMask%(129), MageSprite%(129), MageMask%(129)
DIM SHARED MerchantSprite%(129), MerchantMask%(129), BedLeft%(129), BedRight%(129)
DIM SHARED DialogPictureTemp(1482), AnimeFace%(856), BookCaseTile%(129), InnSignTile%(129)
DIM SHARED TempMenu(3754), DialogTextTemp(9546), ChestTile%(129), WallFaceTile%(129)
DIM SHARED DungeonTile(129), BridgeTile%(129), RoadTile%(129), FloorTile%(129)
DIM SHARED WallSideTile%(129), WallTopTile%(129), ItemTile(129), WeaponTile(129)
DIM SHARED ArmorTile(129), CounterTile(129), DoorTile%(129), WallflagTile%(129)
DIM SHARED TreeTile%(129), HillTile(129), ClearTile%(129), TempTile(129), WaterTile%(129)
DIM SHARED RagnarDown(129), RagnarDownMask(129), RagnarRight(129), RagnarRightMask(129)
DIM SHARED RagnarLeft(129), RagnarLeftMask(129), RagnarUp(129), RagnarUpMask(129)
DIM SHARED map1%(0 TO 19, 0 TO 11), map2%(0 TO 19, 0 TO 11), map3%(0 TO 19, 0 TO 11), map%(0 TO 19, 0 TO 11)
DIM SHARED map4%(0 TO 19, 0 TO 11), map5%(0 TO 19, 0 TO 11), map6%(0 TO 19, 0 TO 11)

DIM SHARED BasicCursor(33), BasicCursorMask(33)
DIM SHARED TalkBuffer$(0 TO 75)

COMMON SHARED name$, rank$, hp%, hpmax%, mp%, mpmax%, strength%, agility%, luck%
COMMON SHARED wisdom%, mana%, weapon$, wmod%, armor$, amod%, attack%, defense%
COMMON SHARED npcname$, filelength%, talkmode$, townname$, anime$, utile%, mode$
COMMON SHARED tempx%, tempy%, row%, column%, player$, facing$, tally%, version$
COMMON SHARED currentmap%, kright$, kleft$, kup$, kdown$, quiy%, decide%, delay%, vlink$
 
CLS : SCREEN 13: CHDIR "D:\QBASIC\RPGS\TERRAB~1\"
 
  OPEN "terrarpg.ini" FOR INPUT AS #1: INPUT #1, mode$, version$, delay%: CLOSE #1
  OPEN "templink.dat" FOR INPUT AS #1: INPUT #1, vlink$: CLOSE #1
  RANDOMIZE TIMER
  MechIcon
  RagnarIcon
  LoadTiles
  LoadMaps
  LoadInfo
  LOCATE 4, 1: COLOR 12: PRINT "Resetting map...": currentmap% = 2: CLS
  ReloadMap
  Mapping
 
  GET (1, 1)-(16, 16), TempTile
 
  kright$ = CHR$(0) + "M": kleft$ = CHR$(0) + "K": kup$ = CHR$(0) + "H": kdown$ = CHR$(0) + "P": kesc$ = CHR$(27): kspace$ = CHR$(32): kenter$ = CHR$(13)
  tempx% = 0: tempy% = 0: column% = 9: row% = 10: player$ = "Kate": facing$ = "UP": CALL UpdateSprites: Moved = 1

DO
  SELECT CASE INKEY$
  CASE kenter$
    CALL TownMenu
  CASE kspace$
    CALL TownTalk
  CASE kright$
    IF column% = 18 AND currentmap% <> 6 AND currentmap% <> 3 THEN
      IF map%(column% + 1, row%) < 5 THEN
        column% = 0: currentmap% = (currentmap% + 1)
        CALL ReloadMap: Moved = 1
      END IF
    END IF
    IF column% < 18 THEN
      IF map%(column% + 1, row%) < 5 THEN column% = column% + 1: Moved = 1
    END IF
    facing$ = "RIGHT": CALL UpdateSprites
  CASE kleft$
    IF column% = 0 AND currentmap% <> 1 AND currentmap% <> 4 THEN
      IF map%(column%, row%) < 5 THEN
        column% = 19: currentmap% = (currentmap% - 1)
        CALL ReloadMap: Moved = 1
      END IF
    END IF
    IF column% > 0 THEN
      IF map%(column% - 1, row%) < 5 THEN column% = column% - 1: Moved = 1
    END IF
    facing$ = "LEFT": CALL UpdateSprites
  CASE kdown$
    IF row% = 11 AND currentmap% > 3 THEN
      IF map%(column%, row%) < 5 THEN
        row% = 0: currentmap% = (currentmap% - 3)
        CALL ReloadMap: Moved = 1
      END IF
    END IF
    IF row% < 11 THEN
      IF map%(column%, row% + 1) < 5 THEN row% = row% + 1: Moved = 1
    END IF
    facing$ = "DOWN": CALL UpdateSprites
  CASE kup$
    IF row% = 0 AND currentmap% < 4 THEN
      row% = 11: currentmap% = (currentmap% + 3)
      CALL ReloadMap: Moved = 1
    END IF
    IF row% > 0 THEN
      IF map%(column%, row% - 1) < 5 THEN row% = row% - 1: Moved = 1
    END IF
    facing$ = "UP": CALL UpdateSprites
  END SELECT

  IF Moved = 1 THEN
    IF map%(column%, row%) = 4 THEN CLEAR : RUN "world2.bas"
    Moved = 0
  END IF
 
LOOP

SUB AnimeLoad (anime$)
 
  IF anime$ = "" THEN EXIT SUB
  ArSize = 861
  OPEN "media\faces\" + anime$ FOR INPUT AS #1:
  INPUT #1, a, B: INPUT #1, ArSize:
  FOR load = 0 TO ArSize:
  INPUT #1, AnimeFace%(load):
  NEXT load: CLOSE #1

  PUT (253, 77), AnimeFace%, PSET
  'LINE (253, 77)-(298, 115), 9, BF
  '(45x38) = ArSize[856]   Current ANIMEBOX area
  '(45x60) = ArSize[1351]  Current ENEMYLARGE tile
  anime$ = ""
    
END SUB

SUB ChangeMap
  
   FOR y = 0 TO 11
     FOR x = 0 TO 19
       IF currentmap% = 1 THEN map1%(x, y) = map%(x, y)
       IF currentmap% = 2 THEN map2%(x, y) = map%(x, y)
       IF currentmap% = 3 THEN map3%(x, y) = map%(x, y)
       IF currentmap% = 4 THEN map4%(x, y) = map%(x, y)
       IF currentmap% = 5 THEN map5%(x, y) = map%(x, y)
       IF currentmap% = 6 THEN map6%(x, y) = map%(x, y)
     NEXT x
   NEXT y

END SUB

SUB CheckTile
       
  IF x = 0 THEN left% = -1: right% = map%(x + 1, y)
  IF x > 0 AND x < 19 THEN left% = map%(x - 1, y): right% = map%(x + 1, y)
  IF x = 19 THEN left% = map%(x - 1, y): right% = -1
  IF y = 0 THEN up% = -1: down% = map%(x, y + 1)
  IF y > 0 AND y < 11 THEN up% = map%(x, y - 1): down% = map%(x, y + 1)
  IF y = 11 THEN up% = map%(x, y - 1): down% = -1
 
  config% = (left% + right% + up% + down%)

  SELECT CASE left%
    CASE -1: left% = -1
    CASE 0: utile% = 0: EXIT SUB
    CASE 1: left% = 1
    CASE 2: left% = 2
    CASE 9: utile% = 2: EXIT SUB
    CASE ELSE: left% = 2
  END SELECT
  SELECT CASE right%
    CASE -1: right% = -1
    CASE 0: utile% = 0: EXIT SUB
    CASE 1: right% = 1
    CASE 2: right% = 2
    CASE 9: utile% = 2: EXIT SUB
    CASE ELSE: right% = 2
  END SELECT
  SELECT CASE up%
    CASE -1: up% = -1
    CASE 0: utile% = 0: EXIT SUB
    CASE 1: up% = 1
    CASE 2: up% = 2
    CASE 9: utile% = 2: EXIT SUB
    CASE ELSE: up% = 2
  END SELECT
  SELECT CASE down%
    CASE -1: down% = -1
    CASE 0: utile% = 0: EXIT SUB
    CASE 1: down% = 1
    CASE 2: down% = 2
    CASE 9: utile% = 2: EXIT SUB
    CASE ELSE: down% = 2
  END SELECT

  config% = (left% + right% + up% + down%)
 
  SELECT CASE config%
    CASE -4 TO -1: utile% = 1
    CASE 0: utile% = 0
    CASE 1: utile% = 1
    CASE 2: utile% = 2
    CASE 3: utile% = 9
    CASE 4: utile% = 1
    CASE 12: utile% = 1
    CASE ELSE: utile% = 0
  END SELECT

EXIT SUB


  utile% = -1
  IF d$ = "Empty" THEN
    IF (l$ = "Grass" AND r$ = "Grass" AND u$ = "Grass") OR (l$ = "Grass" AND r$ = "Grass") OR (l$ = "Grass" AND u$ = "Grass") OR (r$ = "Grass" AND u$ = "Grass") THEN utile% = 0
    IF (l$ = "Floor" AND r$ = "Floor" AND u$ = "Floor") OR (l$ = "Floor" AND r$ = "Floor") OR (l$ = "Floor" AND u$ = "Floor") OR (r$ = "Floor" AND u$ = "Floor") THEN utile% = 2
    IF (l$ = "Road" AND r$ = "Road" AND u$ = "Road") OR (l$ = "Road" AND r$ = "Road") OR (l$ = "Road" AND u$ = "Road") OR (r$ = "Road" AND u$ = "Road") THEN utile% = 1
    IF l$ = "Counter" OR r$ = "Counter" OR u$ = "Counter" THEN utile% = 2
    IF utile% > -1 THEN GOTO TileCheckEnd
  END IF
  IF u$ = "Empty" THEN
    IF (l$ = "Grass" AND r$ = "Grass" AND d$ = "Grass") OR (l$ = "Grass" AND r$ = "Grass") OR (l$ = "Grass" AND d$ = "Grass") OR (r$ = "Grass" AND d$ = "Grass") THEN utile% = 0
    IF (l$ = "Floor" AND r$ = "Floor" AND d$ = "Floor") OR (l$ = "Floor" AND r$ = "Floor") OR (l$ = "Floor" AND d$ = "Floor") OR (r$ = "Floor" AND d$ = "Floor") THEN utile% = 2
    IF (l$ = "Road" AND r$ = "Road" AND d$ = "Road") OR (l$ = "Road" AND r$ = "Road") OR (l$ = "Road" AND d$ = "Road") OR (r$ = "Road" AND d$ = "Road") THEN utile% = 1
    IF l$ = "Counter" OR r$ = "Counter" OR d$ = "Counter" THEN utile% = 2
    IF utile% > -1 THEN GOTO TileCheckEnd
  END IF
  IF r$ = "Empty" THEN
    IF (l$ = "Grass" AND u$ = "Grass" AND d$ = "Grass") OR (l$ = "Grass" AND u$ = "Grass") OR (l$ = "Grass" AND d$ = "Grass") OR (u$ = "Grass" AND d$ = "Grass") THEN utile% = 0
    IF (l$ = "Floor" AND u$ = "Floor" AND d$ = "Floor") OR (l$ = "Floor" AND u$ = "Floor") OR (l$ = "Floor" AND d$ = "Floor") OR (u$ = "Floor" AND d$ = "Floor") THEN utile% = 2
    IF (l$ = "Road" AND u$ = "Road" AND d$ = "Road") OR (l$ = "Road" AND u$ = "Road") OR (l$ = "Road" AND d$ = "Road") OR (u$ = "Road" AND d$ = "Road") THEN utile% = 1
    IF l$ = "Counter" OR u$ = "Counter" OR d$ = "Counter" THEN utile% = 2
    IF utile% > -1 THEN GOTO TileCheckEnd
  END IF
  IF l$ = "Empty" THEN
    IF (r$ = "Grass" AND u$ = "Grass" AND d$ = "Grass") OR (r$ = "Grass" AND u$ = "Grass") OR (r$ = "Grass" AND d$ = "Grass") OR (u$ = "Grass" AND d$ = "Grass") THEN utile% = 0
    IF (r$ = "Floor" AND u$ = "Floor" AND d$ = "Floor") OR (r$ = "Floor" AND u$ = "Floor") OR (r$ = "Floor" AND d$ = "Floor") OR (u$ = "Floor" AND d$ = "Floor") THEN utile% = 2
    IF (r$ = "Road" AND u$ = "Road" AND d$ = "Road") OR (r$ = "Road" AND u$ = "Road") OR (r$ = "Road" AND d$ = "Road") OR (u$ = "Road" AND d$ = "Road") THEN utile% = 1
    IF r$ = "Counter" OR u$ = "Counter" OR d$ = "Counter" THEN utile% = 2
    IF utile% > -1 THEN GOTO TileCheckEnd
  END IF
  IF l$ <> "Empty" AND r$ <> "Empty" AND u$ <> "Empty" AND d$ <> "Empty" THEN
    IF (r$ = "Grass" AND u$ = "Grass" AND d$ = "Grass" AND l$ = "Grass") OR (u$ = "Grass" AND r$ = "Grass" AND d$ = "Grass") OR (r$ = "Grass" AND d$ = "Grass") OR (l$ = "Grass" AND r$ = "Grass" AND d$ = "Grass") OR (l$ = "Grass" AND d$ = "Grass") OR _
 (l$ = "Grass" AND u$ = "Grass") OR (u$ = "Grass" AND r$ = "Grass") OR (u$ = "Grass" AND d$ = "Grass") THEN utile% = 0
    IF (r$ = "Road" AND u$ = "Road" AND d$ = "Road" AND l$ = "Road") OR (u$ = "Road" AND r$ = "Road" AND d$ = "Road") OR (r$ = "Road" AND d$ = "Road") OR (l$ = "Road" AND r$ = "Road" AND d$ = "Road") OR (l$ = "Road" AND d$ = "Road") OR (l$ = "Road"  _
AND u$ = "Road") OR (u$ = "Road" AND r$ = "Road") OR (u$ = "Road" AND d$ = "Road") THEN utile% = 1
    IF (r$ = "Floor" AND u$ = "Floor" AND d$ = "Floor" AND l$ = "Floor") OR (u$ = "Floor" AND r$ = "Floor" AND d$ = "Floor") OR (r$ = "Floor" AND d$ = "Floor") OR (l$ = "Floor" AND r$ = "Floor" AND d$ = "Floor") OR (l$ = "Floor" AND d$ = "Floor") OR _
 (l$ = "Floor" AND u$ = "Floor") OR (u$ = "Floor" AND r$ = "Floor") OR (u$ = "Floor" AND d$ = "Floor") THEN utile% = 2
    IF l$ = "Counter" OR r$ = "Counter" OR u$ = "Counter" OR d$ = "Counter" THEN utile% = 2
    IF utile% > -1 THEN GOTO TileCheckEnd
  END IF
 
  IF utile% = -1 THEN utile% = 2

TileCheckEnd:

END SUB

SUB DecisionBox (choices%, c1$, c2$, c3$, c4$, c5$)

  IF choices% = 0 THEN EXIT SUB
  IF choices% = 1 THEN decide% = 1
   
  'GET (8, 120)-(310, 183), DialogDecisionTemp: COLOR 15
  begin% = 2: yaw% = (yaw% + 1)
  LOCATE yaw%, 26: PRINT "Ŀ": yaw% = (yaw% + 1)
  LOCATE yaw%, 26: PRINT USING " . \      \ "; c1$: yaw% = (yaw% + 1)
  IF choices% = 2 THEN LOCATE yaw%, 26: PRINT USING " . \      \ "; c2$: yaw% = (yaw% + 1)
  IF choices% = 3 THEN LOCATE yaw%, 26: PRINT USING " . \      \ "; c3$: yaw% = (yaw% + 1)
  IF choices% = 4 THEN LOCATE yaw%, 26: PRINT USING " . \      \ "; c4$: yaw% = (yaw% + 1)
  IF choices% = 5 THEN LOCATE yaw%, 26: PRINT USING " . \      \ "; c5$: yaw% = (yaw% + 1)
  LOCATE yaw%, 26: PRINT ""
 
END SUB

SUB DialogBox (clearbox%, picturebox%, textbox%)
  
  IF clearbox% = 1 OR clearbox% = 3 THEN PUT (248, 72), DialogPictureTemp, PSET: ERASE DialogPictureTemp: ERASE AnimeFace%
  IF clearbox% = 2 OR clearbox% = 3 THEN PUT (8, 120), DialogTextTemp, PSET: ERASE DialogTextTemp
  IF picturebox% = 1 THEN
   COLOR 15: GET (248, 72)-(311, 119), DialogPictureTemp
    LOCATE 10, 32: PRINT "Ŀ"
    LOCATE 11, 32: PRINT "     "
    LOCATE 12, 32: PRINT "     "
    LOCATE 13, 32: PRINT "     "
    LOCATE 14, 32: PRINT "     "
    LOCATE 15, 32: PRINT ""
  END IF
  IF textbox% = 1 THEN
    GET (8, 120)-(311, 183), DialogTextTemp: COLOR 15
    LOCATE 16, 2: PRINT "Ŀ"
    LOCATE 17, 2: PRINT "                                    "
    LOCATE 18, 2: PRINT "                                    "
    LOCATE 19, 2: PRINT "                                    "
    LOCATE 20, 2: PRINT "                                    "
    LOCATE 21, 2: PRINT "                                    "
    LOCATE 22, 2: PRINT "                                    "
    LOCATE 23, 2: PRINT ""
  END IF

END SUB

SUB DialogWait (mode%)
 
  'Modes  1 - Bring up the arrow  2 - take down the arrow

  IF mode% = 1 THEN
    LOCATE 23, 36: COLOR 15: PRINT " "
    FOR fade = 16 TO 31: LOCATE 23, 37: COLOR fade: PRINT "": FOR delay = 1 TO delay%: NEXT delay: NEXT fade
    LOCATE 23, 37: COLOR 12: PRINT "": COLOR 15: DO UNTIL INKEY$ = kdown$: LOOP
  END IF
  IF mode% = 2 THEN
    LOCATE 23, 36: COLOR 15: PRINT " "
    FOR fade = 31 TO 16 STEP -1: LOCATE 23, 37: COLOR fade: PRINT "": FOR delay = 1 TO delay%: NEXT delay: NEXT fade
    LOCATE 23, 37: COLOR 0: PRINT "": COLOR 15
  END IF

END SUB

SUB Farewell
  CLS : SCREEN 13
  FOR fade = 16 TO 31
    COLOR fade: LOCATE 2, 16: PRINT "DESIGNER": LOCATE 4, 12: PRINT "Jason  McClaskey": LOCATE 7, 15: PRINT "PROGRAMMER": LOCATE 9, 12: PRINT "Jason  McClaskey": LOCATE 12, 13: PRINT "GRAPHIC DESIGN"
    LOCATE 14, 14: PRINT "Virgil Hobbs": LOCATE 17, 13: PRINT "SPECIAL THANKS": LOCATE 19, 4: PRINT "Virgil - for putting up with me ;)": LOCATE 22, 8: PRINT "(c) 1998 Ryo-Ohki Software": FOR q = 1 TO 250: NEXT q
  NEXT fade: SLEEP 3
  FOR fade = 31 TO 16 STEP -1
    COLOR fade: LOCATE 2, 16: PRINT "DESIGNER": LOCATE 4, 12: PRINT "Jason  McClaskey": LOCATE 7, 15: PRINT "PROGRAMMER": LOCATE 9, 12: PRINT "Jason  McClaskey": LOCATE 12, 13: PRINT "GRAPHIC DESIGN"
    LOCATE 14, 14: PRINT "Virgil Hobbs": LOCATE 17, 13: PRINT "SPECIAL THANKS": LOCATE 19, 4: PRINT "Virgil - for putting up with me ;)": LOCATE 22, 8: PRINT "(c) 1998 Ryo-Ohki Software": FOR q = 1 TO 250: NEXT q
  NEXT fade
  ERASE TempMenu, TalkBuffer$, DialogPictureTemp, AnimeFace%
  ERASE DungeonTile, BridgeTile%, RoadTile%, FloorTile%, WallSideTile%, WallTopTile%, ItemTile, WeaponTile, ArmorTile, CounterTile, DoorTile%
  ERASE TreeTile%, HillTile, ClearTile%, RagnarDown, RagnarDownMask, RagnarRight, RagnarRightMask, RagnarLeft, RagnarLeftMask, RagnarUp, RagnarUpMask
  ERASE TempTile, WaterTile%, map1%, map2%, map3%, map4%, map%
END SUB

SUB HitAnyKey
 
  text$ = "Hit any key to continue..."
  kolor% = 32
  length% = LEN(text$)

  LOCATE 12, (20 - (length% / 2)): PRINT ;

  FOR q = 1 TO length%
    letter$ = MID$(text$, q, (q - q + 1))
    COLOR (q + kolor%): PRINT letter$;
  NEXT q
 
  WHILE INKEY$ = "": WEND

END SUB

SUB LoadInfo
 
  OPEN "quest.tmp" FOR INPUT AS #1
    INPUT #1, name$, rank$, hp%, hpmax%, mp%, mpmax%, strength%
    INPUT #1, agility%, luck%, wisdom%, mana%, weapon$, armor$
    INPUT #1, attack%, defense%, Items$
  CLOSE #1

END SUB

SUB LoadMaps
  
  LOCATE 3, 1: COLOR 12: PRINT "Loading maps     ";
    COLOR 1: PRINT "": LOCATE 3, 17: COLOR 14: PRINT " ";
  
   OPEN ("maps\" + vlink$ + ".map") FOR INPUT AS #1
     INPUT #1, townname$, treasurechests%
     FOR y = 0 TO 11: FOR x = 0 TO 19: INPUT #1, map1%(x, y): NEXT x: NEXT y: INPUT #1, a%: PRINT "";
     FOR y = 0 TO 11: FOR x = 0 TO 19: INPUT #1, map2%(x, y): NEXT x: NEXT y: INPUT #1, a%: PRINT "";
     FOR y = 0 TO 11: FOR x = 0 TO 19: INPUT #1, map3%(x, y): NEXT x: NEXT y: INPUT #1, a%: PRINT "";
     FOR y = 0 TO 11: FOR x = 0 TO 19: INPUT #1, map4%(x, y): NEXT x: NEXT y: INPUT #1, a%: PRINT "";
     FOR y = 0 TO 11: FOR x = 0 TO 19: INPUT #1, map5%(x, y): NEXT x: NEXT y: INPUT #1, a%: PRINT "";
     FOR y = 0 TO 11: FOR x = 0 TO 19: INPUT #1, map6%(x, y): NEXT x: NEXT y: PRINT ""
   CLOSE #1

END SUB

SUB LoadText (tlk$)
 
  '.TLK is limited to 34 width, and 75 length lines

  IF tlk$ <> "blank" THEN
    OPEN ("text\" + townname$ + "\" + tlk$ + ".tlk") FOR INPUT AS #1
      INPUT #1, npcname$, filelength%, talkmode$, anime$
      FOR talkload = 1 TO filelength%
        INPUT #1, TalkBuffer$(talkload)
      NEXT talkload
    CLOSE #1
  END IF
  IF tlk$ = "blank" THEN
    OPEN ("text\blank.tlk") FOR INPUT AS #1
      INPUT #1, npcname$, filelength%, talkmode$, anime$
      FOR talkload = 1 TO filelength%
        INPUT #1, TalkBuffer$(talkload)
      NEXT talkload
    CLOSE #1
  END IF

END SUB

SUB LoadTiles
 
  LOCATE 1, 1: COLOR 12: PRINT "Loading tiles    ";
    COLOR 1: PRINT "": LOCATE 1, 17: COLOR 14: PRINT " ";
   
  ArSize = 129
  OPEN "media\tiles\tiles1.dat" FOR INPUT AS #1:
  INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1, ChestTile%(load): NEXT load: PRINT "";
  INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1, DoorTile%(load): NEXT load: PRINT "";
  INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1, FloorTile%(load): NEXT load: PRINT "";
  INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1, TreeTile%(load): NEXT load: PRINT "";
  INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1, WallSideTile%(load): NEXT load: PRINT "";
  INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1, WallTopTile%(load): NEXT load: PRINT "";
  INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1, WaterTile%(load): NEXT load: PRINT "";
  INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1, BedLeft%(load): NEXT load: PRINT "";
  INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1, BedRight%(load): NEXT load: PRINT "";
  INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1, BookCaseTile%(load): NEXT load: PRINT "";
  INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1, InnSignTile%(load): NEXT load: PRINT "";
  INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1, WallFaceTile%(load): NEXT load: PRINT "";
  INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1, WallflagTile%(load): NEXT load
  INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1, BridgeTile%(load): NEXT load
  INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1, ClearTile%(load): NEXT load
  INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1, RoadTile%(load): NEXT load
  INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1, TavernTile%(load): NEXT load
  INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1, ChestOpenTile%(load): NEXT load
  INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1, MountainTile%(load): NEXT load: PRINT "";
  INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1, HillTile%(load): NEXT load: PRINT "";
  CLOSE #1
  OPEN "media\tiles\tiles1a.dat" FOR INPUT AS #1
  INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1, ClearTile%(load): NEXT load: PRINT "";
  INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1, RoadTile%(load): NEXT load: PRINT "";
  INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1, WallflagTile%(load): NEXT load: PRINT "";
  INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1, TavernTile%(load): NEXT load: PRINT "";
  INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1, BridgeTile%(load): NEXT load: PRINT "";
  INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1, ChestOpenTile%(load): NEXT load: PRINT ""
  CLOSE #1

  LOCATE 2, 1: COLOR 12: PRINT "Loading sprites  ";
    COLOR 1: PRINT "": LOCATE 2, 17: COLOR 14: PRINT " ";

  OPEN "media\sprites\merchant.spx" FOR INPUT AS #1: INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1, MerchantSprite%(load): NEXT load: PRINT ""; : INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1,  _
MerchantMask%(load): NEXT load: CLOSE #1: PRINT "";
  OPEN "media\sprites\knight.spx" FOR INPUT AS #1: INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1, KnightSprite%(load): NEXT load: PRINT ""; : INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1, KnightMask%(load) _
: NEXT load: CLOSE #1: PRINT "";
  OPEN "media\sprites\mage.spx" FOR INPUT AS #1: INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1, MageSprite%(load): NEXT load: PRINT ""; : INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1, MageMask%(load): NEXT _
 load: CLOSE #1: PRINT "";
  OPEN "media\tiles\mousecur.dat" FOR INPUT AS #1: INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO 51: INPUT #1, MouseCursor%(load): NEXT load: PRINT ""; : INPUT #1, a, B: INPUT #1, ArSize: FOR load = 52 TO 102: INPUT #1, MouseCursor%(load): NEXT _
 load: CLOSE #1: PRINT "";
  OPEN "media\sprites\heroine.spx" FOR INPUT AS #1: FOR reloadspx = 0 TO 7: INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1, Kate%(load + (reloadspx * 129)): NEXT load: PRINT ""; : NEXT reloadspx: CLOSE #1
  OPEN "media\sprites\kingd.spx" FOR INPUT AS #1: INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1, KingDownSprite%(load): NEXT load: PRINT ""; : INPUT #1, a, B: INPUT #1, ArSize: FOR load = 0 TO ArSize: INPUT #1, KingDownMask%( _
load): NEXT load: PRINT "": CLOSE #1

END SUB

SUB Mapping
FOR y = 0 TO 11
  FOR x = 0 TO 19
    IF map%(x, y) = 0 THEN
        PUT (x * 16, y * 16), ClearTile%, PSET    'Grass
      ELSEIF map%(x, y) = 1 THEN
        PUT (x * 16, y * 16), RoadTile%, PSET     'Road
      ELSEIF map%(x, y) = 2 THEN
        PUT (x * 16, y * 16), FloorTile%, PSET    'Floor
      ELSEIF map%(x, y) = 3 THEN
        PUT (x * 16, y * 16), BridgeTile%, PSET   'Bridge
      ELSEIF map%(x, y) = 4 THEN
        PUT (x * 16, y * 16), RoadTile%, PSET     'Exit Point
      ELSEIF map%(x, y) = 5 THEN
        PUT (x * 16, y * 16), WallTopTile%, PSET  'Wall (top)
      ELSEIF map%(x, y) = 6 THEN
        PUT (x * 16, y * 16), WallSideTile%, PSET 'Wall (side)
      ELSEIF map%(x, y) = 7 THEN
        PUT (x * 16, y * 16), WaterTile%, PSET    'Water
      ELSEIF map%(x, y) = 8 THEN
        PUT (x * 16, y * 16), TreeTile%, PSET     'Tree
      ELSEIF map%(x, y) = 9 THEN
        PUT (x * 16, y * 16), CounterTile, PSET   'Counter
      ELSEIF map%(x, y) = 10 THEN
        PUT (x * 16, y * 16), DoorTile%, PSET     'Door
      ELSEIF map%(x, y) = 11 THEN
        PUT (x * 16, y * 16), ChestTile%, PSET    'Treasure Chest
      ELSEIF map%(x, y) = 12 THEN
        PUT (x * 16, y * 16), InnSignTile%, PSET  'Inn Sign
      ELSEIF map%(x, y) = 13 THEN
        PUT (x * 16, y * 16), ItemTile, PSET      'Item Sign
      ELSEIF map%(x, y) = 14 THEN
        PUT (x * 16, y * 16), WeaponTile, PSET    'Weapon Sign
      ELSEIF map%(x, y) = 15 THEN
        PUT (x * 16, y * 16), ArmorTile, PSET     'Armor Sign
      ELSEIF map%(x, y) = 16 THEN
        PUT (x * 16, y * 16), ItemTile, PSET      'Magic Sign
      ELSEIF map%(x, y) = 17 THEN
        PUT (x * 16, y * 16), TavernTile%, PSET   'Tavern
      ELSEIF map%(x, y) = 18 THEN
       PUT (x * 16, y * 16), WallFaceTile%, PSET  'Wall (Facing)
      ELSEIF map%(x, y) = 19 THEN
       PUT (x * 16, y * 16), WallflagTile%, PSET  'Wall (Flag)
      '''Decide if its floor, road, or grass
      ELSEIF map%(x, y) > 19 AND map%(x, y) < 41 THEN
        CALL CheckTile
        SELECT CASE utile%
          'CASE 0: PUT (x * 16, y * 16), ClearTile%, PSET
          'CASE 1: PUT (x * 16, y * 16), RoadTile%, PSET
          'CASE 2: PUT (x * 16, y * 16), FloorTile%, PSET
          CASE ELSE: PUT (x * 16, y * 16), FloorTile%, PSET
        END SELECT
        '''Royalty Sprites
        IF map%(x, y) > 19 AND map%(x, y) < 23 THEN
          PUT (x * 16, y * 16), KingDownMask%, AND
          PUT (x * 16, y * 16), KingDownSprite%
        END IF
        '''Merchants Sprites
        IF map%(x, y) > 22 AND map%(x, y) < 28 THEN
          PUT (x * 16, y * 16), MerchantMask%, AND
          PUT (x * 16, y * 16), MerchantSprite%
        END IF
        '''Soldier Sprites
        IF map%(x, y) > 27 AND map%(x, y) < 33 THEN
          PUT (x * 16, y * 16), KnightMask%, AND
          PUT (x * 16, y * 16), KnightSprite%
        END IF
        '''Villagers Sprites
        IF map%(x, y) > 32 AND map%(x, y) < 41 THEN
          PUT (x * 16, y * 16), MageMask%, AND
          PUT (x * 16, y * 16), MageSprite%
        END IF

      ELSEIF map%(x, y) = 41 THEN
        PUT (x * 16, y * 16), BedLeft%, PSET     'Left bedside
      ELSEIF map%(x, y) = 42 THEN
        PUT (x * 16, y * 16), BedRight%, PSET    'Right bedside
      ELSEIF map%(x, y) = 43 THEN
       PUT (x * 16, y * 16), BookCaseTile%, PSET 'BookCase
      ELSEIF map%(x, y) = 44 THEN
       PUT (x * 16, y * 16), ChestOpenTile%, PSET'Open Treasure chest
    END IF
  NEXT x
NEXT y
       
END SUB

SUB MechIcon
 
  LINE (117, 1)-(132, 16), 10, BF: PSET (119, 2), 0
  LINE (122, 5)-(124, 3), 6: PSET (125, 3), 43: LINE (121, 8)-(126, 3), 6: PSET (131, 3), 0
  PSET (124, 4), 43: LINE (126, 4)-(127, 4), 43
  PSET (118, 5), 0: LINE (123, 5)-(117, 11), 6: LINE (125, 5)-(125, 9), 43: PSET (126, 5), 6: LINE (127, 5)-(128, 5), 43
  LINE (121, 6)-(117, 10), 0: LINE (124, 6)-(125, 9), 6: PSET (126, 6), 6: PSET (127, 6), 8: LINE (128, 6)-(131, 9), 6: LINE (129, 6)-(130, 7), 43
  PSET (123, 7), 8: PSET (123, 8), 43: LINE (127, 8)-(128, 7), 43: LINE (129, 8)-(130, 7), 43: PSET (131, 8), 8
  LINE (121, 9)-(122, 8), 6: PSET (123, 9), 6: LINE (124, 7)-(124, 9), 43
  PSET (121, 10), 8: LINE (122, 9)-(122, 10), 43: PSET (127, 10), 0: LINE (127, 9)-(128, 10), 6: LINE (128, 9)-(129, 10), 6: PSET (132, 10), 6
  LINE (118, 11)-(120, 9), 0: LINE (123, 11)-(124, 10), 0: LINE (123, 10)-(124, 11), 6: LINE (126, 7)-(126, 11), 43: PSET (127, 11), 43: LINE (127, 7)-(131, 11), 43: LINE (130, 9)-(132, 11), 6
  LINE (121, 11)-(121, 12), 43: PSET (122, 12), 6: LINE (128, 11)-(128, 12), 0: LINE (129, 11)-(129, 12), 6: LINE (131, 12)-(132, 12), 6
  LINE (117, 12)-(117, 13), 0: LINE (118, 12)-(118, 13), 6: LINE (120, 10)-(120, 12), 6: PSET (120, 13), 43: LINE (121, 13)-(122, 13), 6: LINE (123, 13)-(124, 12), 0: LINE (124, 13)-(122, 11), 6
  LINE (126, 13)-(127, 12), 43: LINE (126, 12)-(127, 13), 6: PSET (128, 13), 43: LINE (128, 12)-(129, 13), 0: LINE (130, 13)-(130, 11), 6: LINE (131, 12)-(131, 13), 6: PSET (132, 13), 0
  LINE (128, 14)-(130, 14), 0: LINE (117, 14)-(118, 14), 0: LINE (119, 11)-(119, 14), 6: PSET (120, 14), 6: LINE (121, 14)-(124, 14), 0: LINE (125, 10)-(125, 14), 6: LINE (126, 14)-(127, 14), 6: LINE (128, 10)-(131, 14), 0
  LINE (118, 15)-(120, 15), 0: LINE (124, 15)-(127, 15), 0
  GET (117, 1)-(132, 16), HillTile
 
CLS
  LINE (1, 1)-(16, 16), 10, BF
  LINE (8, 2)-(10, 2), 8: PSET (12, 2), 8: LINE (5, 1)-(12, 1), 0: LINE -(14, 3), 0
  LINE (10, 3)-(11, 3), 8: LINE (8, 4)-(10, 4), 8: LINE (4, 3)-(4, 4), 8: LINE (13, 3)-(13, 4), 8
  PSET (4, 2), 0: LINE (5, 2)-(12, 4), 8: PSET (6, 2), 0: PSET (7, 2), 7: PSET (11, 2), 0
  LINE (3, 3)-(3, 4), 0: LINE (5, 3)-(5, 4), 0: LINE (6, 3)-(6, 4), 7: PSET (7, 4), 7: PSET (11, 4), 7: LINE (12, 3)-(12, 4), 0: PSET (14, 4), 0
  LINE (2, 5)-(2, 15), 0: LINE (3, 5)-(14, 9), 7, BF: LINE (5, 5)-(7, 7), 8: LINE -(10, 7), 8: LINE -(12, 5), 8
  PSET (6, 5), 0: PSET (11, 5), 0: LINE (7, 6)-(10, 6), 0: LINE (15, 5)-(15, 14), 0
  LINE (3, 7)-(5, 9), 0: PSET (6, 9), 0: LINE (12, 9)-(14, 7), 0: PSET (11, 9), 0
  LINE (14, 8)-(13, 9), 8: PSET (14, 9), 8: LINE (12, 10)-(14, 15), 8, BF: PSET (14, 15), 0
  LINE (3, 10)-(4, 15), 7, BF: PSET (3, 15), 0: PSET (14, 15), 0: PSET (5, 10), 7
  LINE (6, 10)-(11, 14), 0, BF: PSET (11, 10), 8: PSET (6, 10), 8: LINE (5, 11)-(5, 15), 8
  PSET (7, 14), 7: PSET (9, 14), 7: LINE (6, 15)-(7, 15), 0: LINE (9, 15)-(11, 15), 0
  LINE (3, 16)-(6, 16), 0: LINE (10, 16)-(13, 16), 0
GET (1, 1)-(16, 16), DungeonTile: LINE (1, 1)-(16, 16), 0, BF
 
  LINE (1, 1)-(16, 16), 0, BF: LINE (2, 2)-(15, 15), 7, BF
  LINE (4, 2)-(8, 6), 0: LINE (9, 6)-(13, 2), 0: LINE (6, 3)-(11, 3), 4: LINE (7, 4)-(10, 4), 4
  LINE (8, 5)-(9, 5), 4: LINE (2, 4)-(6, 8), 0: LINE (11, 8)-(15, 4), 0
  LINE (2, 5)-(2, 12), 4: LINE (3, 6)-(3, 9), 4: LINE (4, 7)-(4, 8), 4: LINE (5, 8)-(5, 9), 4
  LINE (15, 5)-(15, 12), 4: LINE (14, 6)-(14, 9), 4: LINE (13, 7)-(13, 8), 4: LINE (12, 8)-(12, 9), 4
  LINE (8, 7)-(7, 8), 8: LINE (4, 9)-(3, 10), 0: LINE -(3, 12), 0: PSET (2, 13), 0: PSET (5, 13), 0
  PSET (4, 12), 0: LINE (5, 10)-(6, 9), 0: LINE (9, 10)-(10, 10), 0: PSET (6, 11), 8: LINE (8, 11)-(9, 13), 0, BF: LINE (8, 12)-(9, 12), 4
  LINE (11, 9)-(12, 10), 0: LINE (13, 9)-(14, 10), 0: LINE -(14, 12), 0: PSET (7, 12), 0: PSET (10, 12), 0: PSET (11, 11), 8
  PSET (13, 12), 0: PSET (15, 13), 0: PSET (12, 13), 0: LINE (4, 14)-(3, 15), 8
  LINE (5, 14)-(12, 14), 0: LINE (8, 14)-(9, 14), 4: LINE (13, 14)-(14, 15), 8
  PSET (4, 15), 0: PSET (13, 15), 0: LINE (5, 15)-(12, 15), 4: PSET (10, 9), 0
GET (1, 1)-(16, 16), WeaponTile: LINE (1, 1)-(16, 16), 0, BF
 
  LINE (1, 1)-(16, 16), 0: LINE (3, 1)-(14, 1), 6: LINE (2, 2)-(2, 8), 6: LINE (15, 2)-(15, 8), 6: PSET (3, 2), 6: PSET (14, 2), 6
  LINE (5, 3)-(12, 3), 6: LINE (4, 4)-(4, 6), 6: LINE (5, 7)-(12, 7), 6: LINE (13, 4)-(13, 6), 6: PSET (12, 4), 6
  LINE (5, 4)-(12, 6), 43, BF: PSET (12, 4), 6: PSET (3, 8), 6: PSET (14, 8), 6: LINE (3, 9)-(14, 9), 6
  PSET (2, 10), 6: PSET (15, 10), 6: LINE (3, 11)-(14, 11), 6: PSET (2, 12), 6: PSET (15, 12), 6
  LINE (2, 13)-(3, 15), 6: LINE (4, 13)-(5, 13), 43: LINE (6, 13)-(15, 13), 6: LINE (8, 13)-(9, 13), 43: PSET (11, 13), 43
  LINE (4, 14)-(15, 14), 6: LINE (6, 14)-(7, 14), 43: PSET (10, 14), 43: PSET (12, 14), 43: LINE (14, 15)-(15, 15), 6
  PSET (3, 13), 43: LINE (2, 14)-(2, 15), 6
GET (1, 1)-(16, 16), CounterTile: LINE (1, 1)-(16, 16), 0, BF
 
  LINE (1, 1)-(16, 16), 0, B: LINE (2, 2)-(15, 15), 44, BF
  LINE (2, 5)-(5, 2), 0: LINE (12, 2)-(15, 5), 0: PSET (3, 3), 4: PSET (14, 3), 4
  LINE (6, 3)-(11, 4), 4, BF: LINE (5, 4)-(5, 6), 4: PSET (6, 5), 4: LINE (12, 4)-(14, 6), 4: LINE -(14, 11), 4
  LINE (4, 5)-(4, 9), 4: LINE (3, 6)-(3, 11), 4: LINE (4, 12)-(4, 10), 0: LINE -(5, 9), 0: LINE -(5, 7), 0: LINE -(7, 5), 0: LINE -(12, 5), 0
  LINE (9, 6)-(11, 6), 43: PSET (13, 6), 0: LINE (13, 7)-(13, 12), 4
  LINE (7, 7)-(10, 8), 43, BF: LINE (8, 7)-(12, 7), 0: PSET (12, 8), 0: LINE (6, 9)-(9, 10), 43, BF
  LINE (7, 9)-(11, 9), 0: LINE (12, 9)-(12, 13), 4: PSET (11, 10), 0
  LINE (5, 11)-(6, 11), 43: LINE (7, 11)-(10, 11), 0: PSET (11, 11), 4: LINE (2, 12)-(5, 15), 0: LINE (12, 15)-(15, 12), 0
  PSET (3, 14), 4: PSET (14, 14), 4: LINE (5, 12)-(11, 13), 4, BF: LINE (6, 14)-(11, 14), 4: LINE (5, 12)-(6, 12), 0
GET (1, 1)-(16, 16), ItemTile: LINE (1, 1)-(16, 16), 0, BF

'  k1% = 43: k2% = 44
'  LINE (1, 1)-(16, 16), 0, BF: LINE (5, 2)-(12, 4), k1%, BF: LINE (3, 3)-(4, 5), k1%, BF
'  LINE (2, 4)-(2, 6), k1%: LINE (13, 3)-(14, 5), k1%: LINE (15, 4)-(15, 6), k1%
'  LINE (5, 5)-(12, 5), k2%: LINE (3, 6)-(4, 6), k2%: LINE (2, 7)-(2, 15), k2%: LINE (2, 9)-(2, 10), k1%: LINE (2, 13)-(2, 14), k1%
'  LINE (13, 6)-(14, 6), k2%: LINE -(15, 7), k2%: LINE -(15, 15), k2%: PSET (15, 13), k1%: LINE (15, 9)-(15, 10), k1%
'  LINE (4, 8)-(13, 14), k1%, BF: LINE (5, 7)-(11, 7), k1%: PSET (6, 7), k2%: PSET (9, 7), k2%: PSET (12, 7), k2%
'  LINE (4, 8)-(4, 9), k2%: PSET (6, 9), k2%: LINE (11, 8)-(11, 9), k2%: PSET (8, 9), k2%
'  LINE (6, 10)-(7, 10), 4: LINE (9, 10)-(9, 11), k2%: PSET (4, 11), k2%: LINE (13, 10)-(13, 11), k2%: PSET (11, 11), k2%
'  PSET (6, 12), k2%: LINE (10, 12)-(10, 13), k2%: LINE (12, 13)-(12, 14), k2%: LINE (5, 13)-(5, 14), k2%: LINE (8, 13)-(8, 14), k2%: PSET (7, 14), k2%
'  LINE (2, 16)-(15, 16), k2%: LINE (4, 16)-(5, 16), k1%: PSET (9, 16), k1%: LINE (13, 16)-(14, 16), k1%
'  LINE (1, 1)-(2, 1), 4: PSET (4, 1), 4: LINE (16, 1)-(15, 1), 4: PSET (13, 1), 4
'  PSET (1, 2), 4: PSET (14, 2), 4: PSET (16, 2), 4
'GET (1, 1)-(16, 16), DoorTile: LINE (1, 1)-(16, 16), 0, BF

  LINE (0, 0)-(7, 7), 0, BF: LINE (1, 1)-(7, 4), 15: LINE -(1, 7), 15: LINE -(1, 1), 15: PAINT (3, 3), 15, 15
GET (0, 0)-(7, 7), BasicCursor: LINE (0, 0)-(7, 7), 0
  LINE (0, 0)-(7, 7), 15, BF: LINE (1, 1)-(7, 4), 0: LINE -(1, 7), 0: LINE -(1, 1), 0: PAINT (3, 3), 0, 15
GET (0, 0)-(7, 7), BasicCursorMask: LINE (0, 0)-(7, 7), 0, BF

  LINE (1, 1)-(16, 16), 0, BF
  LINE (2, 2)-(5, 2), 7: LINE (7, 2)-(9, 2), 7: LINE (11, 2)-(15, 2), 7
  LINE (2, 3)-(2, 5), 4: LINE (4, 3)-(4, 4), 4: PSET (3, 4), 4
  LINE (6, 3)-(6, 5), 8: PSET (7, 4), 8: LINE (7, 3)-(10, 3), 7: PSET (13, 3), 4: LINE (15, 3)-(15, 8), 4
  LINE (8, 4)-(10, 4), 7: LINE (12, 4)-(14, 4), 4: PSET (8, 5), 7: PSET (10, 5), 7: PSET (14, 5), 4
  LINE (3, 6)-(5, 6), 7: PSET (8, 6), 7: LINE (11, 6)-(13, 6), 7: PSET (4, 7), 8: PSET (6, 7), 8
  LINE (2, 8)-(2, 12), 4: LINE (4, 9)-(5, 10), 8, BF: LINE (5, 8)-(6, 8), 8: LINE (7, 8)-(7, 11), 7, BF
  LINE (11, 8)-(13, 8), 7: PSET (8, 8), 7: PSET (9, 8), 8: LINE (6, 9)-(6, 10), 7: LINE (8, 9)-(8, 11), 8: LINE (10, 9)-(14, 12), 7, BF
  PSET (6, 11), 8: LINE (11, 9)-(11, 12), 4: LINE (13, 9)-(13, 12), 4: PSET (12, 9), 4: PSET (12, 12), 4
  LINE (4, 12)-(5, 12), 7: LINE (3, 13)-(4, 13), 7: LINE (7, 13)-(8, 13), 7: LINE (11, 13)-(13, 13), 7: PSET (15, 13), 4
  PSET (2, 14), 4: PSET (5, 14), 4: LINE (7, 14)-(9, 14), 7: LINE (14, 14)-(15, 14), 4
  LINE (2, 15)-(6, 15), 7: LINE (10, 15)-(15, 15), 7
GET (1, 1)-(16, 16), ArmorTile: LINE (0, 0)-(16, 16), 0, BF

END SUB

SUB RagnarIcon
  LINE (6, 50)-(9, 50), 1: LINE (10, 50)-(13, 53), 1: LINE (11, 50)-(13, 52), 1
  LINE (5, 51)-(10, 51), 5: LINE (4, 52)-(7, 52), 0: PSET (6, 52), 5: LINE (8, 52)-(11, 52), 5
  LINE (4, 53)-(12, 53), 5: LINE (5, 54)-(7, 54), 15: LINE (6, 54)-(6, 55), 0
  LINE (8, 54)-(12, 54), 5: LINE (13, 54)-(13, 55), 1: LINE (2, 55)-(5, 58), 15: LINE (1, 55)-(4, 58), 15: LINE (1, 56)-(3, 58), 15
  LINE (4, 55)-(5, 55), 15: LINE (7, 55)-(7, 57), 15: LINE (8, 55)-(12, 56), 5, BF
  LINE (5, 56)-(5, 57), 0: LINE (6, 57)-(6, 58), 0: PSET (6, 56), 15: PSET (8, 57), 15
  LINE (9, 57)-(11, 57), 1: LINE (12, 57)-(13, 57), 5: LINE (7, 58)-(11, 58), 5: LINE (12, 58)-(12, 61), 1
  LINE (13, 59)-(13, 62), 1: LINE (14, 61)-(14, 63), 1: PSET (15, 62), 1: LINE (4, 59)-(6, 59), 5, BF
  LINE (7, 59)-(11, 60), 15, BF: PSET (9, 59), 5: LINE (5, 61)-(8, 61), 1: LINE (9, 61)-(10, 61), 15: PSET (11, 61), 5
  LINE (4, 62)-(13, 63), 5, BF: PSET (6, 62), 0: PSET (9, 62), 0: PSET (3, 63), 5
  LINE (4, 64)-(6, 64), 15: LINE (5, 63)-(6, 63), 15: LINE (9, 63)-(10, 65), 15, BF
  LINE (12, 64)-(13, 64), 5: PSET (8, 64), 15: LINE (11, 64)-(11, 65), 15
 
  LINE (8, 67)-(9, 72), 1, BF: LINE (6, 68)-(7, 75), 5, BF: LINE (10, 68)-(11, 75), 5, BF
  LINE (5, 69)-(5, 74), 5: LINE (4, 71)-(4, 72), 5: LINE (12, 69)-(12, 74), 5: LINE (13, 71)-(13, 72), 5
  LINE (8, 73)-(9, 75), 5, BF: PSET (14, 67), 15: LINE (14, 68)-(15, 74), 15
  LINE (4, 76)-(12, 81), 1, BF: LINE (13, 75)-(16, 75), 5: PSET (13, 76), 5: PSET (16, 76), 5
  LINE (2, 74)-(3, 75), 5, BF: PSET (2, 76), 5: LINE (1, 75)-(1, 76), 5: LINE (4, 75)-(5, 75), 1
  PSET (3, 76), 15: LINE (14, 76)-(15, 77), 15, BF: LINE (13, 77)-(13, 81), 1
  LINE (2, 77)-(3, 78), 15, BF: LINE (3, 79)-(3, 81), 1: PSET (2, 81), 1: PSET (15, 81), 1
  LINE (14, 78)-(15, 78), 5: LINE (14, 79)-(14, 81), 1: LINE (9, 82)-(12, 82), 15
 
  LINE (1, 1)-(16, 16), 0, BF
  LINE (8, 1)-(9, 1), 0
  LINE (6, 2)-(11, 2), 5
  LINE (5, 3)-(12, 3), 5: PSET (6, 3), 0: LINE (8, 3)-(9, 3), 0: PSET (11, 3), 0
  PSET (3, 4), 15: LINE (5, 4)-(12, 4), 5: LINE (2, 5)-(3, 5), 15: LINE (4, 5)-(12, 5), 5: PSET (6, 5), 15: PSET (7, 5), 1: LINE (8, 5)-(9, 5), 15: PSET (10, 5), 1: PSET (11, 5), 15
  LINE (2, 6)-(3, 6), 15: LINE (4, 6)-(12, 6), 5: PSET (6, 6), 15: PSET (7, 6), 1: LINE (8, 6)-(9, 6), 15: PSET (10, 6), 1: PSET (11, 6), 15
  LINE (2, 7)-(3, 11), 15, BF: PSET (5, 7), 5: LINE (6, 7)-(7, 7), 15: LINE (8, 7)-(9, 7), 1: LINE (10, 7)-(11, 7), 15: PSET (12, 7), 5
  PSET (5, 8), 5: PSET (6, 8), 15: LINE (7, 8)-(10, 8), 1: PSET (11, 8), 15: PSET (12, 8), 5
  LINE (4, 9)-(5, 9), 1: PSET (6, 9), 5: PSET (7, 9), 1: LINE (8, 9)-(9, 9), 15: PSET (10, 9), 1: PSET (11, 9), 5: LINE (12, 9)-(13, 9), 1: LINE (14, 9)-(15, 9), 5
  LINE (4, 10)-(5, 10), 5: PSET (6, 10), 15: LINE (7, 10)-(10, 10), 5: PSET (11, 10), 15: PSET (12, 10), 5: PSET (13, 10), 15: LINE (14, 10)-(16, 10), 5
  PSET (1, 11), 5: LINE (4, 11)-(7, 11), 5: LINE (8, 11)-(9, 11), 1: LINE (10, 11)-(11, 11), 5: LINE (12, 11)-(14, 11), 15: LINE (15, 11)-(16, 11), 5
  LINE (1, 12)-(4, 12), 5: LINE (5, 12)-(11, 12), 1: LINE (12, 12)-(14, 12), 15
  LINE (2, 13)-(3, 13), 15: PSET (4, 13), 1: LINE (5, 13)-(6, 13), 5: PSET (7, 13), 1: LINE (8, 13)-(9, 13), 5: PSET (10, 13), 1: LINE (11, 13)-(12, 13), 5: LINE (13, 13)-(15, 13), 1
  LINE (4, 14)-(13, 14), 5: PSET (3, 14), 1: PSET (14, 14), 1: LINE (6, 14)-(7, 14), 15: LINE (10, 14)-(11, 14), 15
  LINE (5, 15)-(12, 15), 15: PSET (9, 15), 1
 
  LINE (6, 33)-(11, 33), 1: LINE (5, 34)-(6, 34), 1: LINE (7, 34)-(12, 34), 5
  LINE (4, 35)-(4, 38), 1: LINE (5, 35)-(9, 39), 5, BF: PSET (5, 35), 1: PSET (10, 35), 1: LINE (12, 35)-(13, 35), 1
  PSET (11, 35), 5: LINE (10, 36)-(13, 36), 5: LINE (10, 37)-(10, 39), 15
  LINE (11, 37)-(11, 38), 1: LINE (12, 37)-(12, 38), 15: PSET (13, 38), 15: LINE (15, 38)-(16, 39), 15, BF
  LINE (12, 39)-(12, 40), 1: PSET (11, 39), 15: LINE (14, 39)-(14, 41), 15: LINE (4, 40)-(5, 40), 5
  LINE (6, 40)-(11, 40), 1: PSET (9, 40), 15: PSET (10, 40), 15: PSET (15, 40), 15
  LINE (13, 40)-(13, 42), 15: LINE (5, 41)-(5, 44), 1: LINE (4, 42)-(4, 45), 1: LINE (3, 44)-(3, 46), 1
  PSET (2, 45), 1: PSET (6, 41), 1: LINE (7, 41)-(9, 41), 5: PSET (10, 41), 15: LINE (11, 41)-(10, 42), 1
  LINE (12, 41)-(12, 43), 15: LINE (6, 42)-(6, 46), 5: LINE (7, 42)-(10, 44), 15, BF
  PSET (9, 42), 5: LINE (7, 44)-(7, 45), 5: PSET (11, 42), 15: LINE (11, 43)-(11, 45), 1
  PSET (13, 43), 5: PSET (12, 44), 1: LINE (9, 45)-(10, 46), 5, BF: PSET (10, 45), 1
  LINE (4, 46)-(5, 47), 5, BF: PSET (5, 45), 5: LINE (6, 47)-(7, 47), 15: LINE -(7, 46), 15: LINE (8, 45)-(8, 46), 1
  LINE (12, 45)-(13, 46), 5, BF: PSET (14, 46), 5: LINE (11, 46)-(12, 48), 15, BF
  LINE (10, 47)-(10, 48), 15: PSET (13, 48), 15
 
  GET (1, 1)-(16, 15), RagnarDown
  GET (1, 33)-(16, 48), RagnarRight
  GET (1, 50)-(16, 65), RagnarLeft
  GET (1, 67)-(16, 82), RagnarUp
  LINE (1, 1)-(16, 82), 0, BF
 
  LINE (1, 50)-(16, 66), 255, BF
  LINE (6, 50)-(9, 50), 0: LINE (10, 50)-(13, 53), 0: LINE (11, 50)-(13, 52), 0
  LINE (5, 51)-(10, 51), 0: LINE (4, 52)-(7, 52), 0: PSET (6, 52), 0: LINE (8, 52)-(11, 52), 0
  LINE (4, 53)-(12, 53), 0: LINE (5, 54)-(7, 54), 0: LINE (6, 54)-(6, 55), 0
  LINE (8, 54)-(12, 54), 0: LINE (13, 54)-(13, 55), 0: LINE (2, 55)-(5, 58), 0: LINE (1, 55)-(4, 58), 0: LINE (1, 56)-(3, 58), 0
  LINE (4, 55)-(5, 55), 0: LINE (7, 55)-(7, 57), 0: LINE (8, 55)-(12, 56), 0, BF
  LINE (5, 56)-(5, 57), 0: LINE (6, 57)-(6, 58), 0: PSET (6, 56), 0: PSET (8, 57), 0
  LINE (9, 57)-(11, 57), 0: LINE (12, 57)-(13, 57), 0: LINE (7, 58)-(11, 58), 0: LINE (12, 58)-(12, 61), 0
  LINE (13, 59)-(13, 62), 0: LINE (14, 61)-(14, 63), 0: PSET (15, 62), 0: LINE (4, 59)-(6, 59), 0, BF
  LINE (7, 59)-(11, 60), 0, BF: PSET (9, 59), 0: LINE (5, 61)-(8, 61), 0: LINE (9, 61)-(10, 61), 0: PSET (11, 61), 0
  LINE (4, 62)-(13, 63), 0, BF: PSET (6, 62), 0: PSET (9, 62), 0: PSET (3, 63), 0
  LINE (4, 64)-(6, 64), 0: LINE (5, 63)-(6, 63), 0: LINE (9, 63)-(10, 65), 0, BF
  LINE (12, 64)-(13, 64), 0: PSET (8, 64), 0: LINE (11, 64)-(11, 65), 0
 
  LINE (1, 67)-(16, 82), 255, BF
  LINE (8, 67)-(9, 72), 0, BF: LINE (6, 68)-(7, 75), 0, BF: LINE (10, 68)-(11, 75), 0, BF
  LINE (5, 69)-(5, 74), 0: LINE (4, 71)-(4, 72), 0: LINE (12, 69)-(12, 74), 0: LINE (13, 71)-(13, 72), 0
  LINE (8, 73)-(9, 75), 0, BF: PSET (14, 67), 0: LINE (14, 68)-(15, 74), 0
  LINE (4, 76)-(12, 81), 0, BF: LINE (13, 75)-(16, 75), 0: PSET (13, 76), 0: PSET (16, 76), 0
  LINE (2, 74)-(3, 75), 0, BF: PSET (2, 76), 0: LINE (1, 75)-(1, 76), 0: LINE (4, 75)-(5, 75), 0
  PSET (3, 76), 0: LINE (14, 76)-(15, 77), 0, BF: LINE (13, 77)-(13, 81), 0
  LINE (2, 77)-(3, 78), 0, BF: LINE (3, 79)-(3, 81), 0: PSET (2, 81), 0: PSET (15, 81), 0
  LINE (14, 78)-(15, 78), 0: LINE (14, 79)-(14, 81), 0: LINE (9, 82)-(12, 82), 0
 
  LINE (1, 1)-(16, 16), 255, BF
  LINE (8, 1)-(9, 1), 0
  LINE (6, 2)-(11, 2), 0
  LINE (5, 3)-(12, 3), 0: PSET (6, 3), 0: LINE (8, 3)-(9, 3), 0: PSET (11, 3), 0
  PSET (3, 4), 0: LINE (5, 4)-(12, 4), 0: LINE (2, 5)-(3, 5), 0: LINE (4, 5)-(12, 5), 0: PSET (6, 5), 0: PSET (7, 5), 0: LINE (8, 5)-(9, 5), 0: PSET (10, 5), 0: PSET (11, 5), 0
  LINE (2, 6)-(3, 6), 0: LINE (4, 6)-(12, 6), 0: PSET (6, 6), 0: PSET (7, 6), 0: LINE (8, 6)-(9, 6), 0: PSET (10, 6), 0: PSET (11, 6), 0
  LINE (2, 7)-(3, 11), 0, BF: PSET (5, 7), 0: LINE (6, 7)-(7, 7), 0: LINE (8, 7)-(9, 7), 0: LINE (10, 7)-(11, 7), 0: PSET (12, 7), 0
  PSET (5, 8), 0: PSET (6, 8), 0: LINE (7, 8)-(10, 8), 0: PSET (11, 8), 0: PSET (12, 8), 0
  LINE (4, 9)-(5, 9), 0: PSET (6, 9), 0: PSET (7, 9), 0: LINE (8, 9)-(9, 9), 0: PSET (10, 9), 0: PSET (11, 9), 0: LINE (12, 9)-(13, 9), 0: LINE (14, 9)-(15, 9), 0
  LINE (4, 10)-(5, 10), 0: PSET (6, 10), 0: LINE (7, 10)-(10, 10), 0: PSET (11, 10), 0: PSET (12, 10), 0: PSET (13, 10), 0: LINE (14, 10)-(16, 10), 0
  PSET (1, 11), 0: LINE (4, 11)-(7, 11), 0: LINE (8, 11)-(9, 11), 0: LINE (10, 11)-(11, 11), 0: LINE (12, 11)-(14, 11), 0: LINE (15, 11)-(16, 11), 0
  LINE (1, 12)-(4, 12), 0: LINE (5, 12)-(11, 12), 0: LINE (12, 12)-(14, 12), 0
  LINE (2, 13)-(3, 13), 0: PSET (4, 13), 0: LINE (5, 13)-(6, 13), 0: PSET (7, 13), 0: LINE (8, 13)-(9, 13), 0: PSET (10, 13), 0: LINE (11, 13)-(12, 13), 0: LINE (13, 13)-(15, 13), 0
  LINE (4, 14)-(13, 14), 0: PSET (3, 14), 0: PSET (14, 14), 0: LINE (6, 14)-(7, 14), 0: LINE (10, 14)-(11, 14), 0
  LINE (5, 15)-(12, 15), 0: PSET (9, 15), 0
 
  LINE (1, 33)-(16, 48), 255, BF
  LINE (6, 33)-(11, 33), 0: LINE (5, 34)-(6, 34), 0: LINE (7, 34)-(12, 34), 0
  LINE (4, 35)-(4, 38), 0: LINE (5, 35)-(9, 39), 0, BF: PSET (5, 35), 0: PSET (10, 35), 0: LINE (12, 35)-(13, 35), 0
  PSET (11, 35), 0: LINE (10, 36)-(13, 36), 0: LINE (10, 37)-(10, 39), 0
  LINE (11, 37)-(11, 38), 0: LINE (12, 37)-(12, 38), 0: PSET (13, 38), 0: LINE (15, 38)-(16, 39), 0, BF
  LINE (12, 39)-(12, 40), 0: PSET (11, 39), 0: LINE (14, 39)-(14, 41), 0: LINE (4, 40)-(5, 40), 0
  LINE (6, 40)-(11, 40), 0: PSET (9, 40), 0: PSET (10, 40), 0: PSET (15, 40), 0
  LINE (13, 40)-(13, 42), 0: LINE (5, 41)-(5, 44), 0: LINE (4, 42)-(4, 45), 0: LINE (3, 44)-(3, 46), 0
  PSET (2, 45), 0: PSET (6, 41), 0: LINE (7, 41)-(9, 41), 0: PSET (10, 41), 0: LINE (11, 41)-(10, 42), 0
  LINE (12, 41)-(12, 43), 0: LINE (6, 42)-(6, 46), 0: LINE (7, 42)-(10, 44), 0, BF
  PSET (9, 42), 0: LINE (7, 44)-(7, 45), 0: PSET (11, 42), 0: LINE (11, 43)-(11, 45), 0
  PSET (13, 43), 0: PSET (12, 44), 0: LINE (9, 45)-(10, 46), 0, BF: PSET (10, 45), 0
  LINE (4, 46)-(5, 47), 0, BF: PSET (5, 45), 0: LINE (6, 47)-(7, 47), 0: LINE -(7, 46), 0: LINE (8, 45)-(8, 46), 0
  LINE (12, 45)-(13, 46), 0, BF: PSET (14, 46), 0: LINE (11, 46)-(12, 48), 0, BF
  LINE (10, 47)-(10, 48), 0: PSET (13, 48), 0
 
  GET (1, 1)-(16, 15), RagnarDownMask
  GET (1, 33)-(16, 48), RagnarRightMask
  GET (1, 50)-(16, 65), RagnarLeftMask
  GET (1, 67)-(16, 82), RagnarUpMask
  LINE (1, 1)-(16, 82), 0, BF

END SUB

SUB ReloadMap
  
   FOR y = 0 TO 11
     FOR x = 0 TO 19
       IF currentmap% = 1 THEN map%(x, y) = map1%(x, y)
       IF currentmap% = 2 THEN map%(x, y) = map2%(x, y)
       IF currentmap% = 3 THEN map%(x, y) = map3%(x, y)
       IF currentmap% = 4 THEN map%(x, y) = map4%(x, y)
       IF currentmap% = 5 THEN map%(x, y) = map5%(x, y)
       IF currentmap% = 6 THEN map%(x, y) = map6%(x, y)
     NEXT x
   NEXT y
  
   CALL Mapping
   GET ((tempx% * 16), (tempy% * 16))-((tempx% * 16) + 16, (tempy% * 16) + 16), TempTile

END SUB

SUB TownItemsMenu

   menu% = 1: menucolumn% = 1: menurow% = 1
   COLOR 15: LOCATE 2, 5: PRINT "Ŀ"
   COLOR 15: LOCATE 3, 5: PRINT "                              "
   COLOR 15: LOCATE 4, 5: PRINT "                              "
   COLOR 15: LOCATE 5, 5: PRINT "                              "
   COLOR 15: LOCATE 6, 5: PRINT "                              "
   COLOR 15: LOCATE 7, 5: PRINT "                              "
   COLOR 15: LOCATE 8, 5: PRINT "                              "
   COLOR 15: LOCATE 9, 5: PRINT "                              "
  COLOR 15: LOCATE 10, 5: PRINT "                              "
  COLOR 15: LOCATE 11, 5: PRINT "                              "
  COLOR 15: LOCATE 12, 5: PRINT "                              "
  COLOR 15: LOCATE 13, 5: PRINT "                              "
  COLOR 15: LOCATE 14, 5: PRINT ""

  MoveCursor = 1

DO
  SELECT CASE INKEY$
    CASE CHR$(13)       'Return
      IF menu% = 1 THEN
        IF menurow% = 1 THEN
          'CALL TownTalk
          'IF quiy% = 0 THEN : CALL DialogBox(0, 0, 1): LOCATE 17, 4: PRINT "There's no one in that direction. ": CALL DialogWait(1): CALL DialogWait(2): CALL DialogBox(2, 0, 0): EXIT DO
          'quiy% = 0: EXIT DO
          SYSTEM
        END IF
        IF menurow% = 2 THEN
          CALL TownSearch
          IF quiy% = 0 THEN : CALL DialogBox(0, 0, 1): LOCATE 17, 4: PRINT "There's nothing to search for     ": LOCATE 18, 4: PRINT "here.                             ": CALL DialogWait(1): CALL DialogWait(2): : CALL DialogBox(2, 0, 0): EXIT DO
          IF quiy% = 1 THEN CALL Mapping: CALL UpdateSprites: quiy% = 0: EXIT SUB
        END IF
        IF menurow% = 3 THEN
          IF facing$ = "DOWN" AND map%(column%, row% + 1) = 10 THEN map%(column%, row% + 1) = 2: quiy% = 1
          IF facing$ = "RIGHT" AND map%(column% + 1, row%) = 10 THEN map%(column% + 1, row%) = 2: quiy% = 1
          IF facing$ = "LEFT" AND map%(column% - 1, row%) = 10 THEN map%(column% - 1, row%) = 2: quiy% = 1
          IF facing$ = "UP" AND map%(column%, row% - 1) = 10 THEN map%(column%, row% - 1) = 2: quiy% = 1
          IF quiy% = 0 THEN CALL DialogBox(0, 0, 1): LOCATE 17, 4: PRINT "There's no door in that direction.": CALL DialogWait(1): CALL DialogWait(2): : CALL DialogBox(2, 0, 0): EXIT DO
          IF quiy% = 1 THEN CALL Mapping: CALL UpdateSprites: quiy% = 0: EXIT SUB
          '                 \--- CALL ChangeMap
        END IF
        IF menurow% = 4 THEN SYSTEM
        IF menurow% = 8 THEN EXIT DO
      END IF
    CASE kup$
      IF menurow% = 1 THEN menurow% = 11: MoveCursor = 1
      IF menurow% > 1 AND MoveCursor = 0 THEN menurow% = (menurow% - 1): MoveCursor = 1
    CASE kdown$
      IF menurow% = 11 THEN menurow% = 1: MoveCursor = 1
      IF menurow% < 11 AND MoveCursor = 0 THEN menurow% = (menurow% + 1): MoveCursor = 1
    CASE kleft$
      'IF menucolumn% = 2 THEN menucolumn% = 1: MoveCursor = 1
    CASE kright$
      'IF menucolumn% = 1 THEN menucolumn% = 2: MoveCursor = 1
  END SELECT
  IF MoveCursor = 1 THEN
    LINE (41, 16)-(50, 103), 0, BF
    PUT ((menucolumn% * 11) + 30, (menurow% * 8) + 7), MouseCursor%(0), PSET
    MoveCursor = 0
  END IF
LOOP


END SUB

SUB TownMenu

 GET (8, 8)-(103, 87), TempMenu

   menu% = 1: menucolumn% = 1: menurow% = 1
   COLOR 15: LOCATE 2, 2: PRINT "Ŀ"
   COLOR 15: LOCATE 3, 2: PRINT "   ";
     COLOR 10: PRINT "TALK   ";
     COLOR 15: PRINT ""
   COLOR 15: LOCATE 4, 2: PRINT "   ";
     COLOR 10: PRINT "SEARCH ";
     COLOR 15: PRINT ""
   COLOR 15: LOCATE 5, 2: PRINT "   ";
     COLOR 10: PRINT "DOOR   ";
     COLOR 15: PRINT ""
   COLOR 15: LOCATE 6, 2: PRINT "   ";
     COLOR 12: PRINT "FILE   ";
     COLOR 15: PRINT ""
   COLOR 15: LOCATE 7, 2: PRINT "   ";
     COLOR 10: PRINT "STATUS ";
     COLOR 15: PRINT ""
   COLOR 15: LOCATE 8, 2: PRINT "   ";
     COLOR 2: PRINT "SPELLS ";
     COLOR 15: PRINT ""
   COLOR 15: LOCATE 9, 2: PRINT "   ";
     COLOR 2: PRINT "ITEMS  ";
     COLOR 15: PRINT ""
   COLOR 15: LOCATE 10, 2: PRINT "   ";
     COLOR 10: PRINT "EXIT   ";
     COLOR 15: PRINT ""
  COLOR 15: LOCATE 11, 2: PRINT ""
 
  MoveCursor = 1

DO
  SELECT CASE INKEY$
    CASE CHR$(13)       'Return
      IF menu% = 1 THEN
        IF menurow% = 1 THEN
          CALL TownTalk
          IF quiy% = 0 THEN : CALL DialogBox(0, 0, 1): LOCATE 17, 4: PRINT "There's no one in that direction. ": CALL DialogWait(1): CALL DialogWait(2): CALL DialogBox(2, 0, 0): EXIT DO
          quiy% = 0: EXIT DO
        END IF
        IF menurow% = 2 THEN
          CALL TownSearch
          IF quiy% = 0 THEN : CALL DialogBox(0, 0, 1): LOCATE 17, 4: PRINT "There's nothing to search for     ": LOCATE 18, 4: PRINT "here.                             ": CALL DialogWait(1): CALL DialogWait(2): : CALL DialogBox(2, 0, 0): EXIT DO
          IF quiy% = 1 THEN CALL Mapping: CALL UpdateSprites: quiy% = 0: EXIT SUB
        END IF
        IF menurow% = 3 THEN
          IF facing$ = "DOWN" AND map%(column%, row% + 1) = 10 THEN map%(column%, row% + 1) = 2: quiy% = 1
          IF facing$ = "RIGHT" AND map%(column% + 1, row%) = 10 THEN map%(column% + 1, row%) = 2: quiy% = 1
          IF facing$ = "LEFT" AND map%(column% - 1, row%) = 10 THEN map%(column% - 1, row%) = 2: quiy% = 1
          IF facing$ = "UP" AND map%(column%, row% - 1) = 10 THEN map%(column%, row% - 1) = 2: quiy% = 1
          IF quiy% = 0 THEN CALL DialogBox(0, 0, 1): LOCATE 17, 4: PRINT "There's no door in that direction.": CALL DialogWait(1): CALL DialogWait(2): : CALL DialogBox(2, 0, 0): EXIT DO
          IF quiy% = 1 THEN CALL Mapping: CALL UpdateSprites: quiy% = 0: EXIT SUB
          '                 \--- CALL ChangeMap
        END IF
        IF menurow% = 4 THEN SYSTEM
        IF menurow% = 5 THEN PUT (8, 8), TempMenu, PSET: ERASE TempMenu: CALL TownStatusMenu: EXIT SUB
        IF menurow% = 8 THEN EXIT DO
      END IF
    CASE kup$
      IF menurow% = 1 THEN menurow% = 8: MoveCursor = 1
      IF menurow% > 1 AND MoveCursor = 0 THEN menurow% = (menurow% - 1): MoveCursor = 1
    CASE kdown$
      IF menurow% = 8 THEN menurow% = 1: MoveCursor = 1
      IF menurow% < 8 AND MoveCursor = 0 THEN menurow% = (menurow% + 1): MoveCursor = 1
    CASE kleft$
    CASE kright$
  END SELECT
  IF MoveCursor = 1 THEN
    LINE (21, 16)-(30, 79), 0, BF
    PUT ((menucolumn% * 11) + 10, (menurow% * 8) + 7), MouseCursor%(0), PSET
    MoveCursor = 0
  END IF
LOOP

  PUT (8, 8), TempMenu, PSET
  ERASE TempMenu

END SUB

SUB TownSearch
 
  IF facing$ = "DOWN" THEN C% = 0: r% = 1
  IF facing$ = "UP" THEN C% = 0: r% = -1
  IF facing$ = "RIGHT" THEN C% = 1: r% = 0
  IF facing$ = "LEFT" THEN C% = -1: r% = 0
   
    SELECT CASE map%(column% + C%, row% + r%)
      CASE 7: GOTO Found15
      CASE 8: GOTO Found16
      CASE 9: GOTO Found17
      CASE 10: GOTO Found18
      CASE 12: GOTO Found12
      CASE 11: map%(column% + C%, row% + r%) = 44: CALL ChangeMap: GOTO Found19
      CASE 13: GOTO Found21
      CASE 14: GOTO Found22
      CASE 15: GOTO Found23
      CASE 16: GOTO Found24
      CASE 17: GOTO Found25
      CASE 19: GOTO Found19a
      CASE 41: GOTO Found41
      CASE 42: GOTO Found41
      CASE 43: GOTO Found43
      CASE 44: GOTO Found44
    END SELECT
 
  GOTO quiy

Found12:
  CALL DialogBox(0, 0, 1): LOCATE 17, 4: PRINT "A sign hangs on a rusted pole on a": LOCATE 18, 4: PRINT "building before you.  It reads,   ": LOCATE 19, 4: PRINT townname$; " Inn. Welcome!": CALL DialogWait(1): CALL DialogWait(2): CALL DialogBox(2 _
, 0, 0): quiy% = 1: GOTO quiy
Found15:
  CALL DialogBox(0, 0, 1): LOCATE 17, 4: PRINT "You see a flowing expanse of pure ": LOCATE 18, 4: PRINT "blue water before you.            ": CALL DialogWait(1): CALL DialogWait(2): : CALL DialogBox(2, 0, 0): quiy% = 1: GOTO quiy
Found16:
  CALL DialogBox(0, 0, 1): LOCATE 17, 4: PRINT "You can see a grove of grasses,   ": LOCATE 18, 4: PRINT "trees, and shrubberies.           ": CALL DialogWait(1): CALL DialogWait(2): : CALL DialogBox(2, 0, 0): quiy% = 1: GOTO quiy
Found17:
  CALL DialogBox(0, 0, 1): LOCATE 17, 4: PRINT "There is a counter before you.    ": CALL DialogWait(1): CALL DialogWait(2): : CALL DialogBox(2, 0, 0): quiy% = 1: GOTO quiy
Found18:
  CALL DialogBox(0, 0, 1): LOCATE 17, 4: PRINT "There is an iron door before you.": CALL DialogWait(1): CALL DialogWait(2): : CALL DialogBox(2, 0, 0): quiy% = 1: GOTO quiy
Found19:
  CALL DialogBox(0, 0, 1): LOCATE 17, 4: PRINT "You see a treasure chest.         ": LOCATE 18, 4: PRINT "[Place decision box code here]    ": LOCATE 19, 4: PRINT "You found [item]!                 "
  CALL DialogWait(1): CALL DialogWait(2): CALL DialogBox(2, 0, 0): quiy% = 1: GOTO quiy
Found19a:
  CALL DialogBox(0, 0, 1): LOCATE 17, 4: PRINT "You see the banner crest of the   ": LOCATE 18, 4: PRINT "House of Kaeson and the Tamar     ": LOCATE 19, 4: PRINT "kingdom.                          "
  CALL DialogWait(1): CALL DialogWait(2): CALL DialogBox(2, 0, 0): quiy% = 1: GOTO quiy
Found21:
  CALL DialogBox(0, 0, 1): LOCATE 17, 4: PRINT "An aging building sits along the  ": LOCATE 18, 4: PRINT "path, with many unique objects in "
  LOCATE 19, 4: PRINT "the window.  'Diosd Item Traders.'": CALL DialogWait(1): CALL DialogWait(2): : CALL DialogBox(2, 0, 0): quiy% = 1: GOTO quiy
Found22:
  CALL DialogBox(0, 0, 1): LOCATE 17, 4: PRINT "A weapon shop is there.  'Greff's ": LOCATE 18, 4: PRINT "Armor and Weapons Emporium.'      ": CALL DialogWait(1): CALL DialogWait(2): : CALL DialogBox(2, 0, 0): quiy% = 1: GOTO quiy
Found23:
  CALL DialogBox(0, 0, 1): LOCATE 17, 4: PRINT "An armor shop lays before you. The": LOCATE 18, 4: PRINT "sign above it reads 'Greff's Armor"
  LOCATE 19, 4: PRINT "and Weapons Emporium.'            ": CALL DialogWait(1): CALL DialogWait(2): : CALL DialogBox(2, 0, 0): quiy% = 1: GOTO quiy
Found24:
  CALL DialogBox(0, 0, 1): LOCATE 17, 4: PRINT "A sign fills your vision, and even"
  LOCATE 18, 4: PRINT "seems to allow energy to flow from": LOCATE 19, 4: PRINT "it to you.  It reads, 'Leoben's   "
  LOCATE 20, 4: PRINT "Magic Guild Shop.'                ": CALL DialogWait(1): CALL DialogWait(2): : CALL DialogBox(2, 0, 0): quiy% = 1: GOTO quiy
Found25:
  CALL DialogBox(0, 0, 1): LOCATE 17, 4: PRINT "There is a sign before you.  It   ": LOCATE 18, 4: PRINT "reads, 'Yohko's Pub Place.'       ": CALL DialogWait(1): CALL DialogWait(2): : CALL DialogBox(2, 0, 0): quiy% = 1: GOTO quiy
Found41:
  CALL DialogBox(0, 0, 1): LOCATE 17, 4: PRINT "A well-made oaken bed is before   ": LOCATE 18, 4: PRINT "you.                              ": CALL DialogWait(1): CALL DialogWait(2): CALL DialogBox(2, 0, 0): quiy% = 1: GOTO quiy
Found43:
  CALL DialogBox(0, 0, 1): LOCATE 17, 4: PRINT "Several books lie on a shelf.  The": LOCATE 18, 4: PRINT "titles include many illuminated   ": LOCATE 19, 4: PRINT "scripts, as well as old novels.   ": CALL DialogWait(1): CALL DialogWait(2): : CALL  _
DialogBox(2, 0, 0): quiy% = 1: GOTO quiy
Found44:
  CALL DialogBox(0, 0, 1): LOCATE 17, 4: PRINT "You find a treasure chest! However": LOCATE 18, 4: PRINT "its empty...                      ": CALL DialogWait(1): CALL DialogWait(2): : CALL DialogBox(2, 0, 0): quiy% = 1: GOTO quiy

quiy:
 
END SUB

SUB TownStatusMenu

   menu% = 1: menucolumn% = 1: menurow% = 1
   COLOR 15: LOCATE 2, 5: PRINT "Ŀ"
   COLOR 15: LOCATE 3, 5: PRINT " ";
     COLOR 10: PRINT USING "\               \ \        \"; name$; rank$;
     COLOR 15: PRINT " ";
     COLOR 15: PRINT ""
   COLOR 15: LOCATE 4, 5: PRINT "                              "
   COLOR 15: LOCATE 5, 5: PRINT " ";
     COLOR 2: PRINT "HP:     ";
     COLOR 10: PRINT USING "###/### "; hp%; hpmax%;
     COLOR 2: PRINT "Strength:";
     COLOR 10: PRINT USING "### "; strength%;
     COLOR 15: PRINT ""
   COLOR 15: LOCATE 6, 5: PRINT "                              "
   COLOR 15: LOCATE 7, 5: PRINT " ";
     COLOR 2: PRINT "MP:     ";
     COLOR 10: PRINT USING "###/### "; mp%; mpmax%;
     COLOR 2: PRINT "Agility: ";
     COLOR 10: PRINT USING "### "; agility%;
     COLOR 15: PRINT ""
   COLOR 15: LOCATE 8, 5: PRINT "                              "
   COLOR 15: LOCATE 9, 5: PRINT " ";
     COLOR 2: PRINT "MP:     ";
     COLOR 10: PRINT USING "###     "; mp%;
     COLOR 2: PRINT "Luck:    ";
     COLOR 10: PRINT USING "### "; luck%;
     COLOR 15: PRINT ""
  COLOR 15: LOCATE 10, 5: PRINT "                              "
  COLOR 15: LOCATE 11, 5: PRINT " ";
    COLOR 2: PRINT "MP Max: ";
    COLOR 10: PRINT USING "###     "; mpmax%;
    COLOR 2: PRINT "Wisdom:  ";
    COLOR 10: PRINT USING "### "; wisdom%;
    COLOR 15: PRINT ""
  COLOR 15: LOCATE 12, 5: PRINT "                              "
  COLOR 15: LOCATE 13, 5: PRINT " ";
    COLOR 2: PRINT "Mana:     ";
    COLOR 10: PRINT USING "#                  "; mana%;
    COLOR 15: PRINT ""
  COLOR 15: LOCATE 14, 5: PRINT ""

  WHILE INKEY$ = "": WEND
  Mapping
  UpdateSprites

END SUB

SUB TownTalk

  quiy% = 1
  IF facing$ = "DOWN" AND row% < 11 THEN
    subject% = map%(column%, row% + 1)
    IF row% < 10 THEN
      IF map%(column%, row% + 1) = 9 THEN subject% = map%(column%, row% + 2)
    END IF
  END IF
  IF facing$ = "UP" AND row% > 0 THEN
    subject% = map%(column%, row% - 1)
    IF row% > 1 THEN
      IF map%(column%, row% - 1) = 9 THEN subject% = map%(column%, row% - 2)
    END IF
  END IF
  IF facing$ = "RIGHT" AND column% < 18 THEN
    subject% = map%(column% + 1, row%)
    IF row% < 17 THEN
      IF map%(column% + 1, row%) = 9 THEN subject% = map%(column% + 2, row%)
    END IF
  END IF
  IF facing$ = "LEFT" AND column% > 0 THEN
    subject% = map%(column% - 1, row%)
    IF row% > 1 THEN
      IF map%(column% - 1, row%) = 9 THEN subject% = map%(column% - 2, row%)
    END IF
  END IF
 
  subject$ = "blank": Speak% = 1
  IF subject% = 20 THEN subject$ = "royalty1"
  IF subject% = 21 THEN subject$ = "royalty2"
  IF subject% = 22 THEN subject$ = "royalty3"
  IF subject% = 23 THEN subject$ = "merchnt1"
  IF subject% = 24 THEN subject$ = "merchnt2"
  IF subject% = 25 THEN subject$ = "merchnt3"
  IF subject% = 26 THEN subject$ = "merchnt4"
  IF subject% = 27 THEN subject$ = "merchnt5"
  IF subject% = 28 THEN subject$ = "soldier1"
  IF subject% = 29 THEN subject$ = "soldier2"
  IF subject% = 30 THEN subject$ = "soldier3"
  IF subject% = 31 THEN subject$ = "soldier4"
  IF subject% = 32 THEN subject$ = "soldier5"
  IF subject% = 33 THEN subject$ = "vilagr1"
  IF subject% = 34 THEN subject$ = "vilagr2"
  IF subject% = 35 THEN subject$ = "vilagr3"
  IF subject% = 36 THEN subject$ = "vilagr4"
  IF subject% = 37 THEN subject$ = "vilagr5"
  IF subject% = 38 THEN subject$ = "vilagr6"
  IF subject% = 39 THEN subject$ = "vilagr7"
  IF subject% = 40 THEN subject$ = "vilagr8"

    IF subject$ = "blank" THEN quiy% = 0: Speak% = 0
    IF Speak% = 1 THEN CALL LoadText(subject$): GOTO TalkEngine: Speak% = 0
  GOTO Quiyer
 

TalkEngine:
  CALL DialogBox(0, 1, 1): COLOR 15: CALL AnimeLoad(anime$)
  FOR display = 1 TO filelength% STEP 6
    LOCATE 17, 4: PRINT TalkBuffer$(display)
    LOCATE 18, 4: PRINT TalkBuffer$(display + 1)
    LOCATE 19, 4: PRINT TalkBuffer$(display + 2)
    LOCATE 20, 4: PRINT TalkBuffer$(display + 3)
    LOCATE 21, 4: PRINT TalkBuffer$(display + 4)
    LOCATE 22, 4: PRINT TalkBuffer$(display + 5)
    CALL DialogWait(1): CALL DialogWait(2)
    IF display >= filelength% - 6 THEN EXIT FOR
    FOR scroll = 1 TO 6
      LOCATE 17, 4: PRINT TalkBuffer$(display + scroll)
      LOCATE 18, 4: PRINT TalkBuffer$(display + scroll + 1)
      LOCATE 19, 4: PRINT TalkBuffer$(display + scroll + 2)
      LOCATE 20, 4: PRINT TalkBuffer$(display + scroll + 3)
      LOCATE 21, 4: PRINT TalkBuffer$(display + scroll + 4)
      LOCATE 22, 4: PRINT TalkBuffer$(display + scroll + 5)
    NEXT scroll
  NEXT display
  
  CALL DialogBox(3, 0, 0): quiy% = 1: ERASE TalkBuffer$: CALL LoadText("blank"): GOTO Quiyer

Quiyer:

END SUB

SUB UpdateSprites
 
  PUT ((tempx% * 16), (tempy% * 16)), TempTile, PSET
  GET ((column% * 16), (row% * 16))-((column% * 16) + 15, (row% * 16) + 15), TempTile
  IF player$ = "Ragnar" THEN
    IF facing$ = "DOWN" THEN
      PUT ((column% * 16), (row% * 16)), RagnarDownMask, AND
      PUT ((column% * 16), (row% * 16)), RagnarDown
    END IF
    IF facing$ = "RIGHT" THEN
      PUT ((column% * 16), (row% * 16)), RagnarRightMask, AND
      PUT ((column% * 16), (row% * 16)), RagnarRight
    END IF
    IF facing$ = "LEFT" THEN
      PUT ((column% * 16), (row% * 16)), RagnarLeftMask, AND
      PUT ((column% * 16), (row% * 16)), RagnarLeft
    END IF
    IF facing$ = "UP" THEN
      PUT ((column% * 16), (row% * 16)), RagnarUpMask, AND
      PUT ((column% * 16), (row% * 16)), RagnarUp
    END IF
  END IF
  IF player$ = "Kate" THEN
    IF facing$ = "LEFT" THEN
      PUT ((column% * 16), (row% * 16)), Kate%(129), AND
      PUT ((column% * 16), (row% * 16)), Kate%(0)
    END IF
    IF facing$ = "UP" THEN
      PUT ((column% * 16), (row% * 16)), Kate%(645), AND
      PUT ((column% * 16), (row% * 16)), Kate%(516)
    END IF
    IF facing$ = "RIGHT" THEN
      PUT ((column% * 16), (row% * 16)), Kate%(903), AND
      PUT ((column% * 16), (row% * 16)), Kate%(774)
    END IF
    IF facing$ = "DOWN" THEN
      PUT ((column% * 16), (row% * 16)), Kate%(387), AND
      PUT ((column% * 16), (row% * 16)), Kate%(258)
    END IF
  END IF
 
  tempy% = row%: tempx% = column%
 
END SUB

